/*
 * ̃vO̒쌠AgpAۏ؂̔۔FɂẮA
 * "LICENCE.txt"QƂ̂
 */

/* 
 * `cϊvOif[^P擾E\EL^j
 * Ver. 1.0 
 */

/* ̃t@C(measurement.cpp)́Av̏Ɋւ鏔֐܂ށB
 */

#include	<windows.h>
#include	<stdio.h>
#include	<process.h>
#include	<math.h>

#include	"resource.h"
#include	"measurement.h"
#include	"state.h"
#include	"option.h"
#include	"def_channel.h"

/* Ot@CŒ`ꂽ֐̐錾ivg^Cv錾j
 * O[oϐ̐錾
 */
	/* "winmain.cpp"QƂ̂ */
	void DisplayInformation (char *buf);
	extern HWND	hwnd_dlg;

	/* "display.cpp"QƂ̂ */
	void RefreshDisplay();
	void SetCircle (double x_pos, double y_pos);

	/* "save.cpp"QƂ̂ */
	void SaveInTheFile (DWORD option, char *sbuf);
	void SaveMemo();

	/* "timer.cpp"QƂ̂ */
	void TimeMillisecond (double *pTime);
	void TimeSecond (double *pTime);

	/* "converter.cpp"QƂ̂ */
	void GetSingleAdData (DWORD channel, double *pData);

/* ̃t@CŒ`֐̐錾ivg^Cv錾j */
unsigned _stdcall Measurement (void *param);

/* ̃t@CŒ`O[oϐ̐錾 */
DWORD	measurement_state;
HANDLE	hComEvent;		/* handle to event object for thread communication */
HANDLE	hTriggerEvent;

/************* ̃t@CŌĂяo֐ *****************************/
void InitMeasurement()
{
	hComEvent = CreateEvent (NULL, FALSE, FALSE, NULL);
	if (!hComEvent) {
		DisplayInformation ("error: hComEvent = CreateEvent()");
	}

	hTriggerEvent = CreateEvent (NULL, FALSE, FALSE, NULL);
	if (!hTriggerEvent) {
		DisplayInformation ("error: hComEvent = CreateEvent()");
	}

	return;
}

void RegisterState (DWORD state)
{
	measurement_state = state;
	return;
}

void StartMeasurement()
{
	HANDLE	threadHandle;	
	DWORD	threadID;

	threadHandle = (HANDLE)_beginthreadex(0, 0, Measurement, 
					NULL, 0, (unsigned *) &threadID);
	CloseHandle (threadHandle);
	return;
}

void TriggerMeasurement()
{
	SetEvent(hTriggerEvent);
	return;
}

void StopMeasurement()
{
	SetEvent(hComEvent);
	SetEvent(hTriggerEvent);
	return;
}

void EndMeasurement()
{ 
	CloseHandle (hComEvent);
	CloseHandle (hTriggerEvent);
	return;
}

/************* ̃t@Cł̂ݎgp֐ ***********************/
unsigned _stdcall Measurement (void *param)
{
	DWORD count;
	double	time_0, time_1, elapsed_time;

	double	voltage;	

	char	cbuf[STRING_LENGTH]	= "";

	count = 1;

	while (1) {
		if (WaitForSingleObject(hTriggerEvent, INFINITE) == WAIT_OBJECT_0){
			if (WaitForSingleObject(hComEvent, 0) == WAIT_OBJECT_0)
			break;
		}
	
		sprintf (cbuf, "%d", count);
		SetDlgItemText (hwnd_dlg, IDC_COUNT, cbuf);

		if (count==1) {
			RefreshDisplay();
			elapsed_time = 0;
			TimeSecond (&time_0);	/* ̎擾 */
		}

		/* f[^̎擾 */
		GetSingleAdData (CH1, &voltage);
		TimeSecond (&time_1);	/* ̎擾 */ 

		/* oߎԂ̌vZƕ\ */
		elapsed_time = elapsed_time + (time_1 - time_0);
		time_0 = time_1;
		sprintf (cbuf, "%5.2f", elapsed_time);
		SetDlgItemText (hwnd_dlg, IDC_ELAPSED_TIME, cbuf);

		/* f[^̕\ */
		SetCircle (elapsed_time/T_MAX, voltage/V_MAX);

		if (measurement_state == SAVE) {/* vȂf[^ۑ */
			if (count==1) {
				sprintf (cbuf, "Number\tTime(s)\tVoltage(V)\r\n");
				SaveInTheFile (NEW, cbuf);
			}
			sprintf(cbuf,"%d\t%f\t%f\t\r\n", count, elapsed_time, voltage);
			SaveInTheFile (EXISTING, cbuf);	
		}
		count++;		
	}

	SaveMemo();

	return 0;
}