/*
 * ̃vO̒쌠AgpAۏ؂̔۔FɂẮA
 * "LICENCE.txt"QƂ̂
 */

/* 
 * `cϊvOif[^500擾E\EL^j
 * Ver. 1.0 
 */

/* ̃t@C(measurement.cpp)́Av̏Ɋւ鏔֐܂ށB
 */

#include	<windows.h>
#include	<stdio.h>
#include	<process.h>
#include	<math.h>

#include	"resource.h"
#include	"measurement.h"
#include	"state.h"
#include	"option.h"
#include	"def_channel.h"

/* Ot@CŒ`ꂽ֐̐錾ivg^Cv錾j
 * O[oϐ̐錾
 */
	/* "winmain.cpp"QƂ̂ */
	void DisplayInformation (char *buf);
	extern HWND	hwnd_dlg;

	/* "display.cpp"QƂ̂ */
	void RefreshDisplay();
	void DrawPixel (double x_pos, double y_pos);
	void UpdateDisplay();

	/* "save.cpp"QƂ̂ */
	void SaveInTheFile (DWORD option, char *affix, char *sbuf);
	void SaveMemo();

	/* "timer.cpp"QƂ̂ */
	void TimeMillisecond (double *pTime);
	void TimeSecond (double *pTime);

	/* "converter.cpp"QƂ̂ */
	void GetMultipleAdData (DWORD channel, DWORD data_num, double *pSmplFreq, double *pData);

/* ̃t@CŒ`֐̐錾ivg^Cv錾j */
unsigned _stdcall Measurement (void *param);

/* ̃t@CŒ`O[oϐ̐錾 */
static	DWORD	measurement_state;
static	HANDLE	hComEvent;		/* handle to event object for thread communication */
static	HANDLE	hTriggerEvent;

/************* ̃t@CŌĂяo֐ *****************************/
void InitMeasurement()
{
	hComEvent = CreateEvent (NULL, FALSE, FALSE, NULL);
	if (!hComEvent) {
		DisplayInformation ("error: hComEvent = CreateEvent()");
	}

	hTriggerEvent = CreateEvent (NULL, FALSE, FALSE, NULL);
	if (!hTriggerEvent) {
		DisplayInformation ("error: hComEvent = CreateEvent()");
	}

	return;
}

void RegisterState (DWORD state)
{
	measurement_state = state;
	return;
}

void StartMeasurement()
{
	HANDLE	threadHandle;	
	DWORD	threadID;

	threadHandle = (HANDLE)_beginthreadex(0, 0, Measurement, 
					NULL, 0, (unsigned *) &threadID);
	CloseHandle (threadHandle);
	return;
}

void TriggerMeasurement()
{
	SetEvent(hTriggerEvent);
	return;
}

void StopMeasurement()
{
	SetEvent(hComEvent);
	SetEvent(hTriggerEvent);
	return;
}

void EndMeasurement()
{ 
	CloseHandle (hComEvent);
	CloseHandle (hTriggerEvent);
	return;
}

/************* ̃t@Cł̂ݎgp֐ ***********************/
unsigned _stdcall Measurement (void *param)
{
	DWORD count;
	double	time_0, time_1, elapsed_time;

	double	freq;
	double	voltage[DATA_NUMBER];
	
	DWORD	i;
	char	cbuf[STRING_LENGTH]	= "";
	char	sbuf[STRING_LENGTH]	= "";

	count = 1;

	while (1) {
		if (WaitForSingleObject(hTriggerEvent, INFINITE) == WAIT_OBJECT_0){
			if (WaitForSingleObject(hComEvent, 0) == WAIT_OBJECT_0)
			break;
		}
	
		sprintf (cbuf, "%d", count);
		SetDlgItemText (hwnd_dlg, IDC_COUNT, cbuf);

		if (count==1) {
			elapsed_time = 0;
			TimeSecond (&time_0);	/* ̎擾 */
		}

		/* f[^̎擾 */
		GetMultipleAdData (CH1, DATA_NUMBER, &freq, voltage);
		TimeSecond (&time_1);	/* ̎擾 */ 

		/* oߎԂ̌vZƕ\ */
		elapsed_time = elapsed_time + (time_1 - time_0);
		time_0 = time_1;
		sprintf (cbuf, "%5.2f", elapsed_time);
		SetDlgItemText (hwnd_dlg, IDC_ELAPSED_TIME, cbuf);

		/* f[^̕\ */
		RefreshDisplay();
		for (i = 0;i < DATA_NUMBER;i++) {
			DrawPixel ((double)i/DATA_NUMBER, voltage[i]/V_MAX);
		}
		UpdateDisplay();

		/* f[^̕ۑ */
		if (measurement_state == SAVE) {/* vȂf[^ۑ */
			sprintf (cbuf, "_%d", count);
			sprintf (sbuf, "Number\tVoltage(V)\tTime(s)\tFrequency(Hz)\r\n");
			SaveInTheFile (NEW, cbuf, sbuf);

			sprintf (sbuf, "0\t%f\t%f\t%f\r\n", voltage[0], elapsed_time, freq);
			SaveInTheFile (EXISTING, cbuf, sbuf);		
			for (i = 1;i < DATA_NUMBER;i++) {
				sprintf (sbuf, "%d\t%f\r\n", i, voltage[i]);
				SaveInTheFile (EXISTING, cbuf, sbuf);
			}
		}

		count++;		
	}

	SaveMemo();

	return 0;
}