/*
 * ̃vO̒쌠AgpAۏ؂̔۔FɂẮA
 * "LICENCE.txt"QƂ̂
 */

/* 
 * `cϊvOif[^500擾E\EL^j
 * Ver. 1.0 
 */

/* ̃t@C(display.cpp)́Af[^\pʂɊւ鏔֐܂ށB
 */

#include	<windows.h>
#include	<stdio.h>

#include	"display.h"

/* Ot@CŒ`ꂽ֐̐錾ivg^Cv錾j
 * O[oϐ̐錾
 */
	/* "winmain.cpp"QƂ̂ */
	void DisplayInformation (char * buf);
	extern HWND	hwnd_dlg;

/* ̃t@CŒ`֐̐錾ivg^Cv錾j */
void DefineWndclass (WNDCLASSEX *pWndclass, WNDPROC lpfnWndProc, HINSTANCE hInstance, LPCTSTR lpszClassName);
LRESULT CALLBACK WindowFunc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

void RefreshDisplay();	

/* ̃t@CŒ`O[oϐ̐錾 */
static	HWND	hwnd_gr;	/* handle to display window */

static	HDC		memdc;		/* handle to memory device context */
static	HBITMAP	hbit;		/* handle to virtual bitmap */

/************* ̃t@CŌĂяo֐ *****************************/
/* InitDisplay: initialize the display object */
void InitDisplay()
{
	HINSTANCE	hi0;
	WNDCLASSEX	mwndclass;
	
	char	cbuf[STRING_LENGTH] = "";

	hi0 = (HINSTANCE) GetWindowLong (hwnd_dlg, GWL_HINSTANCE);

	DefineWndclass (&mwndclass, WindowFunc, hi0, "Display");
	if(! RegisterClassEx( &mwndclass ))	
		DisplayInformation ("Error: RegisterClassEx()");

	/* create display window */
	hwnd_gr = CreateWindow (	"Display",	
								NULL,
								WS_CHILD | WS_VISIBLE | WS_BORDER,
								X_WINDOW_POS, Y_WINDOW_POS,		
								X_WINDOW_SIZE, Y_WINDOW_SIZE,	
								hwnd_dlg,						
								NULL, hi0, NULL
							);			

	return;
}

/* ʍV֐ĩt@CłĂяoj */
void RefreshDisplay()
{
	HPEN	hPen;	/* ynh */
	
	/* zʂ̔wiFiݒj */
	PatBlt (memdc, 0, 0, X_WINDOW_SIZE, Y_WINDOW_SIZE, BLACKNESS);

	/* y̏x[XC̕`恁I */
	hPen = CreatePen (PS_SOLID, 1, GREEN);		/* y̐F̍쐬 */
	SelectObject (memdc, hPen);					/* y̑I */
	MoveToEx (memdc , 0 , BASELINE, NULL);		/* x[XC̕` */
	LineTo (memdc , X_WINDOW_SIZE, BASELINE);	/* ij */
	DeleteObject (hPen);						/* yIuWFNg̍폜 */

	InvalidateRect(hwnd_gr, NULL, FALSE);

	return;
}

void DrawPixel (double x_pos, double y_pos)
{
	int x_point, y_point;

	/* W̌vZ */
	x_point = X_WINDOW_SIZE * x_pos;
	y_point = Y_WINDOW_SIZE/2 * (1- y_pos);

	SetPixel (memdc, x_point, y_point, RED);

	return;
}

void UpdateDisplay()
{
	InvalidateRect(hwnd_gr, NULL, FALSE);
	return;
}

/************* ̃t@Cł̂ݎgp֐ ***********************/
void DefineWndclass (WNDCLASSEX *pWndclass, WNDPROC lpfnWndProc, HINSTANCE hInstance, LPCTSTR lpszClassName)
{
	pWndclass->cbSize			= sizeof(WNDCLASSEX);
	pWndclass->style			= 0;
	pWndclass->lpfnWndProc		= lpfnWndProc;
	pWndclass->cbClsExtra		= 0;
	pWndclass->cbWndExtra		= 0;
	pWndclass->hInstance		= hInstance;
	pWndclass->hIcon			= NULL;
	pWndclass->hCursor			= NULL;
	pWndclass->hbrBackground	= (HBRUSH)GetStockObject( BLACK_BRUSH );
	pWndclass->lpszMenuName		= NULL;	
	pWndclass->lpszClassName	= lpszClassName;
	pWndclass->hIconSm			= NULL;

	return;
}

LRESULT CALLBACK WindowFunc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC				hdc;
	PAINTSTRUCT		ps;

	switch(msg){
	case WM_CREATE:	
		/* zʂ̍쐬 */
		hdc = GetDC (hwnd_gr);
		memdc = CreateCompatibleDC (hdc);			
		hbit  = CreateCompatibleBitmap (hdc, X_WINDOW_SIZE, Y_WINDOW_SIZE);
		SelectObject (memdc, hbit);
		PatBlt (memdc, 0, 0, X_WINDOW_SIZE, Y_WINDOW_SIZE, BLACKNESS);
		ReleaseDC (hwnd_gr, hdc);

		RefreshDisplay();	/* x[XC̕` */
		break;
	case WM_PAINT:
		hdc = BeginPaint (hwnd_gr, &ps);	
		BitBlt	(	hdc, 
					ps.rcPaint.left, 
					ps.rcPaint.top, 
					ps.rcPaint.right - ps.rcPaint.left, 
					ps.rcPaint.bottom - ps.rcPaint.top, 
					memdc, 
					ps.rcPaint.left, 
					ps.rcPaint.top, 
					SRCCOPY 
				);
		EndPaint (hwnd_gr, &ps);
		break;
	case WM_DESTROY:
		DeleteDC (memdc);
		DeleteObject (hbit);
	default:
		return DefWindowProc (hwnd, msg, wParam, lParam);
	}
	return 0;
}