/*
 * ̃vO̒쌠AgpAۏ؂̔۔FɂẮA
 * "LICENCE.txt"QƂ̂
 */

/* 
 * `cϊvOif[^500擾E\EL^j
 * Ver. 1.0 
 */

/*
 * ̃t@C(winmain.cpp)́A WinMain֐ƃ[U[C^tF[XƂĂ 
 * _CAO{bNXɊ֌W鏔֐܂ށB
 */

#include	<windows.h>
#include	<stdio.h>

#include	"resource.h"
#include	"state.h"

/* Ot@CŒ`ꂽ֐̐錾ivg^Cv錾j */
	/* "display.cpp"QƂ̂ */
	void InitDisplay();
	
	/* "measurement.cpp"QƂ̂ */	
	void InitMeasurement();
	void RegisterState (DWORD state);
	void StartMeasurement();
	void StopMeasurement();
	void EndMeasurement();

	/* "save.cpp"QƂ̂ */
	void InitSave();	
	
	/* "timer.cpp"QƂ̂ */	
	void InitTime();
	void StartTimer();
	void StopTimer();
	void EndTime();
	
	/* "converter.cpp"QƂ̂ */	
	void InitConverter();
	void EndConverter();

/* ̃t@CŒ`֐̐錾ivg^Cv錾j */
void DefineWndclass (WNDCLASSEX *pWndclass, WNDPROC lpfnWndProc, HINSTANCE hInstance, LPCTSTR lpszClassName);
BOOL CALLBACK DialogFunc (HWND, UINT, WPARAM, LPARAM);

/* ̃t@CŒ`O[oϐ̐錾 */
HWND	hwnd_dlg;

/************* ̃t@Cyё̃t@CŌĂяo֐ *************/
void DisplayInformation (char * buf)
{	
	DWORD i;
	
	for( i = 0; i < strlen(buf); i++ ){
		SendDlgItemMessage (hwnd_dlg, IDC_EDIT_MESSAGE, WM_CHAR, buf[i], NULL);
	} 
	SendDlgItemMessage (hwnd_dlg, IDC_EDIT_MESSAGE, WM_CHAR, 0x0d, NULL);

	return;
}

/************* ̃t@Cł̂ݎgp֐ **************************/
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE, LPSTR, int)
{
	DialogBox (hInstance, MAKEINTRESOURCE( IDD_DIALOG1 ), HWND_DESKTOP, (DLGPROC)DialogFunc);

	return 0;
}

BOOL CALLBACK DialogFunc (HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static DWORD state;

	switch (msg){
	case WM_INITDIALOG:{
		hwnd_dlg = hwnd;
		InitDisplay();
		InitMeasurement();
		InitSave();
		InitTime();
		InitConverter();
		
		state = OFF;
		return TRUE;
	}

	case WM_COMMAND:
		switch (LOWORD(wp)){
		case IDC_BUTTON1:
			switch (state){
			case OFF:
				DisplayInformation ("Start display!");
				state = DISPLAY;
				RegisterState (state);
				StartMeasurement();
				StartTimer();
				break;

			case DISPLAY:
				DisplayInformation ("Stop display!");
				state = OFF;
				StopMeasurement();
				StopTimer();
				break;
			}
			return TRUE;

		case IDC_BUTTON2:
			switch (state){
			case OFF:
				DisplayInformation ("Start save!");
				state = SAVE;
				RegisterState (state);
				StartMeasurement();
				StartTimer();
				break;

			case SAVE:
				DisplayInformation ("Stop save!");
				state = OFF;
				StopMeasurement();
				StopTimer();
			}
			return TRUE;

		case IDCANCEL:
			EndDialog( hwnd, -1 );		
			EndMeasurement();
			EndTime();
			EndConverter();
			
			return TRUE;
		}
	}
	return FALSE;
}/* BOOL CALLBACK DialogFunc (HWND hwnd, UINT msg, WPARAM wp, LPARAM lp) */
